diff --git a/sbin/newfs_hammer2/newfs_hammer2.c b/sbin/newfs_hammer2/newfs_hammer2.c
index e67927c81a..6d4be29e0d 100644
--- a/sbin/newfs_hammer2/newfs_hammer2.c
+++ b/sbin/newfs_hammer2/newfs_hammer2.c
@@ -33,9 +33,9 @@
  */
 
 #include <sys/types.h>
+#include <sys/param.h>
 #include <sys/diskslice.h>
 #include <sys/diskmbr.h>
-#include <sys/stat.h>
 #include <sys/time.h>
 #include <sys/sysctl.h>
 #include <sys/ioctl.h>
@@ -58,14 +58,12 @@
 
 #define MAXLABELS	HAMMER2_SET_COUNT
 
-static hammer2_off_t check_volume(const char *path, int *fdp);
 static int64_t getsize(const char *str, int64_t minval, int64_t maxval, int pw);
 static uint64_t nowtime(void);
 static int blkrefary_cmp(const void *b1, const void *b2);
 static void usage(void);
 
-static void format_hammer2(int fd, hammer2_off_t total_space,
-				hammer2_off_t free_space);
+static void format_hammer2(hammer2_ondisk_t *fso, int index);
 static void alloc_direct(hammer2_off_t *basep, hammer2_blockref_t *bref,
 				size_t bytes);
 
@@ -80,16 +78,15 @@ static const char *Label[MAXLABELS];
 static hammer2_off_t BootAreaSize;
 static hammer2_off_t AuxAreaSize;
 static int NLabels;
+static int DebugOpt;
 
 int
 main(int ac, char **av)
 {
 	uint32_t status;
-	hammer2_off_t total_space;
-	hammer2_off_t free_space;
-	hammer2_off_t reserved_space;
+	hammer2_off_t reserved_size;
+	hammer2_ondisk_t fso;
 	int ch;
-	int fd = -1;
 	int i;
 	int defaultlabels = 1;
 	char *vol_fsid = NULL;
@@ -125,7 +122,7 @@ main(int ac, char **av)
 	/*
 	 * Parse arguments
 	 */
-	while ((ch = getopt(ac, av, "L:b:r:V:")) != -1) {
+	while ((ch = getopt(ac, av, "L:b:r:V:d")) != -1) {
 		switch(ch) {
 		case 'L':
 			defaultlabels = 0;
@@ -167,6 +164,9 @@ main(int ac, char **av)
 				     Hammer2Version);
 			}
 			break;
+		case 'd':
+			DebugOpt = 1;
+			break;
 		default:
 			usage();
 			break;
@@ -202,10 +202,11 @@ main(int ac, char **av)
 	ac -= optind;
 	av += optind;
 
-	if (ac != 1 || av[0][0] == 0) {
-		fprintf(stderr, "Exactly one disk device must be specified\n");
-		exit(1);
-	}
+	if (ac == 0)
+		errx(1, "You must specify at least one disk device");
+	if (ac > HAMMER2_MAX_VOLUMES)
+		errx(1, "The maximum number of volumes is %d",
+		     HAMMER2_MAX_VOLUMES);
 
 	/*
 	 * Adjust Label[] and NLabels.
@@ -221,15 +222,38 @@ main(int ac, char **av)
 	}
 
 	/*
-	 * Collect volume information.
+	 * Construct volumes information.
+	 * 1GB alignment (level1 freemap size) for volumes except for the last.
+	 * For the last volume, typically 8MB alignment to avoid edge cases for
+	 * reserved blocks and so raid stripes (if any) operate efficiently.
 	 */
-	total_space = check_volume(av[0], &fd);
+	hammer2_init_ondisk(&fso);
+	fso.version = Hammer2Version;
+	fso.nvolumes = ac;
+	for (i = 0; i < fso.nvolumes; ++i) {
+		hammer2_volume_t *vol = &fso.volumes[i];
+		hammer2_off_t size;
+		int fd = open(av[i], O_RDWR);
+		if (fd < 0)
+			err(1, "Unable to open %s R+W", av[i]);
+		size = check_volume(fd);
+		if (i == fso.nvolumes - 1)
+			size &= ~HAMMER2_VOLUME_ALIGNMASK64;
+		else
+			size &= ~HAMMER2_FREEMAP_LEVEL1_MASK;
+		hammer2_install_volume(vol, fd, i, av[i], fso.total_size, size);
+		fso.total_size += size;
+	}
 
 	/*
-	 * ~typically 8MB alignment to avoid edge cases for reserved blocks
-	 * and so raid stripes (if any) operate efficiently.
+	 * Verify volumes constructed above.
 	 */
-	total_space &= ~HAMMER2_VOLUME_ALIGNMASK64;
+	for (i = 0; i < fso.nvolumes; ++i) {
+		hammer2_volume_t *vol = &fso.volumes[i];
+		printf("Volume %-15s size %s\n", vol->path,
+		       sizetostr(vol->size));
+	}
+	hammer2_verify_volumes(&fso, NULL);
 
 	/*
 	 * Calculate defaults for the boot area size and round to the
@@ -240,7 +264,7 @@ main(int ac, char **av)
 	 */
 	if (BootAreaSize == 0) {
 		BootAreaSize = HAMMER2_BOOT_NOM_BYTES;
-		while (BootAreaSize > total_space / 20)
+		while (BootAreaSize > fso.total_size / 20)
 			BootAreaSize >>= 1;
 		if (BootAreaSize < HAMMER2_BOOT_MIN_BYTES)
 			BootAreaSize = HAMMER2_BOOT_MIN_BYTES;
@@ -259,7 +283,7 @@ main(int ac, char **av)
 	 */
 	if (AuxAreaSize == 0) {
 		AuxAreaSize = HAMMER2_AUX_NOM_BYTES;
-		while (AuxAreaSize > total_space / 20)
+		while (AuxAreaSize > fso.total_size / 20)
 			AuxAreaSize >>= 1;
 		if (AuxAreaSize < HAMMER2_AUX_MIN_BYTES)
 			AuxAreaSize = HAMMER2_AUX_MIN_BYTES;
@@ -290,28 +314,38 @@ main(int ac, char **av)
 	 *     boundaries rather than 2GB boundaries.  Stick with the LEVEL1
 	 *     boundary.
 	 */
-	reserved_space = ((total_space + HAMMER2_FREEMAP_LEVEL1_MASK) /
+	reserved_size = ((fso.total_size + HAMMER2_FREEMAP_LEVEL1_MASK) /
 			  HAMMER2_FREEMAP_LEVEL1_SIZE) * HAMMER2_ZONE_SEG64;
 
-	free_space = total_space - reserved_space - BootAreaSize - AuxAreaSize;
-	if ((int64_t)free_space < 0) {
+	fso.free_size = fso.total_size - reserved_size - BootAreaSize - AuxAreaSize;
+	if ((int64_t)fso.free_size < 0) {
 		fprintf(stderr, "Not enough free space\n");
 		exit(1);
 	}
 
-	format_hammer2(fd, total_space, free_space);
-	fsync(fd);
-	close(fd);
+	/*
+	 * Format HAMMER2 volumes.
+	 */
+	for (i = 0; i < fso.nvolumes; ++i)
+		format_hammer2(&fso, i);
 
 	printf("---------------------------------------------\n");
 	printf("version:          %d\n", Hammer2Version);
 	printf("total-size:       %s (%jd bytes)\n",
-	       sizetostr(total_space),
-	       (intmax_t)total_space);
-	printf("boot-area-size:   %s\n", sizetostr(BootAreaSize));
-	printf("aux-area-size:    %s\n", sizetostr(AuxAreaSize));
-	printf("topo-reserved:    %s\n", sizetostr(reserved_space));
-	printf("free-space:       %s\n", sizetostr(free_space));
+	       sizetostr(fso.total_size),
+	       (intmax_t)fso.total_size);
+	printf("boot-area-size:   %s (%jd bytes)\n",
+	       sizetostr(BootAreaSize),
+	       (intmax_t)BootAreaSize);
+	printf("aux-area-size:    %s (%jd bytes)\n",
+	       sizetostr(AuxAreaSize),
+	       (intmax_t)AuxAreaSize);
+	printf("topo-reserved:    %s (%jd bytes)\n",
+	       sizetostr(reserved_size),
+	       (intmax_t)reserved_size);
+	printf("free-size:        %s (%jd bytes)\n",
+	       sizetostr(fso.free_size),
+	       (intmax_t)fso.free_size);
 	printf("vol-fsid:         %s\n", vol_fsid);
 	printf("sup-clid:         %s\n", sup_clid_name);
 	printf("sup-fsid:         %s\n", sup_fsid_name);
@@ -322,6 +356,10 @@ main(int ac, char **av)
 		printf("    clid %s\n", pfs_clid_name);
 		printf("    fsid %s\n", pfs_fsid_name);
 	}
+	if (DebugOpt) {
+		printf("---------------------------------------------\n");
+		hammer2_print_volumes(&fso);
+	}
 
 	free(vol_fsid);
 	free(sup_clid_name);
@@ -329,6 +367,9 @@ main(int ac, char **av)
 	free(pfs_clid_name);
 	free(pfs_fsid_name);
 
+	for (i = 0; i < fso.nvolumes; ++i)
+		hammer2_uninstall_volume(&fso.volumes[i]);
+
 	return(0);
 }
 
@@ -338,7 +379,7 @@ usage(void)
 {
 	fprintf(stderr,
 		"usage: newfs_hammer2 [-b bootsize] [-r auxsize] "
-		"[-V version] [-L label ...] special\n"
+		"[-V version] [-L label ...] special ...\n"
 	);
 	exit(1);
 }
@@ -411,94 +452,24 @@ nowtime(void)
 	return(xtime);
 }
 
-/*
- * Figure out how big the volume is.
- */
 static
 hammer2_off_t
-check_volume(const char *path, int *fdp)
-{
-	struct partinfo pinfo;
-	struct stat st;
-	hammer2_off_t size;
-
-	/*
-	 * Get basic information about the volume
-	 */
-	*fdp = open(path, O_RDWR);
-	if (*fdp < 0)
-		err(1, "Unable to open %s R+W", path);
-	if (ioctl(*fdp, DIOCGPART, &pinfo) < 0) {
-		/*
-		 * Allow the formatting of regular files as HAMMER2 volumes
-		 */
-		if (fstat(*fdp, &st) < 0)
-			err(1, "Unable to stat %s", path);
-		if (!S_ISREG(st.st_mode))
-			errx(1, "Unsupported file type for %s", path);
-		size = st.st_size;
-	} else {
-		/*
-		 * When formatting a block device as a HAMMER2 volume the
-		 * sector size must be compatible.  HAMMER2 uses 64K
-		 * filesystem buffers but logical buffers for direct I/O
-		 * can be as small as HAMMER2_LOGSIZE (16KB).
-		 */
-		if (pinfo.reserved_blocks) {
-			errx(1, "HAMMER2 cannot be placed in a partition "
-				"which overlaps the disklabel or MBR");
-		}
-		if (pinfo.media_blksize > HAMMER2_PBUFSIZE ||
-		    HAMMER2_PBUFSIZE % pinfo.media_blksize) {
-			errx(1, "A media sector size of %d is not supported",
-			     pinfo.media_blksize);
-		}
-		size = pinfo.media_size;
-	}
-	printf("Volume %-15s size %s\n", path, sizetostr(size));
-	return (size);
-}
-
-/*
- * Create the volume header, the super-root directory inode, and
- * the writable snapshot subdirectory (named via the label) which
- * is to be the initial mount point, or at least the first mount point.
- * newfs_hammer2 doesn't format the freemap bitmaps for these.
- *
- * 0                      4MB
- * [----reserved_area----][boot_area][aux_area]
- * [[vol_hdr][freemap]...]                     [sroot][root][root]...
- *     \                                        ^\     ^     ^
- *      \--------------------------------------/  \---/-----/---...
- *
- * NOTE: The passed total_space is 8MB-aligned to avoid edge cases.
- */
-static
-void
-format_hammer2(int fd, hammer2_off_t total_space, hammer2_off_t free_space)
+format_hammer2_misc(hammer2_volume_t *vol, hammer2_off_t boot_base,
+		    hammer2_off_t aux_base)
 {
 	char *buf = malloc(HAMMER2_PBUFSIZE);
-	hammer2_volume_data_t *voldata;
-	hammer2_inode_data_t *rawip;
-	hammer2_blockref_t sroot_blockref;
-	hammer2_blockref_t root_blockref[MAXLABELS];
-	uint64_t now;
-	hammer2_off_t volu_base = 0;
-	hammer2_off_t boot_base = HAMMER2_ZONE_SEG;
-	hammer2_off_t aux_base = boot_base + BootAreaSize;
 	hammer2_off_t alloc_base = aux_base + AuxAreaSize;
 	hammer2_off_t tmp_base;
 	size_t n;
 	int i;
 
 	/*
-	 * Clear the entire 4MB reserve for the first 2G zone and
-	 * make sure we can write to the last block.
+	 * Clear the entire 4MB reserve for the first 2G zone.
 	 */
 	bzero(buf, HAMMER2_PBUFSIZE);
-	tmp_base = volu_base;
+	tmp_base = 0;
 	for (i = 0; i < HAMMER2_ZONE_BLOCKS_SEG; ++i) {
-		n = pwrite(fd, buf, HAMMER2_PBUFSIZE, tmp_base);
+		n = pwrite(vol->fd, buf, HAMMER2_PBUFSIZE, tmp_base);
 		if (n != HAMMER2_PBUFSIZE) {
 			perror("write");
 			exit(1);
@@ -506,13 +477,6 @@ format_hammer2(int fd, hammer2_off_t total_space, hammer2_off_t free_space)
 		tmp_base += HAMMER2_PBUFSIZE;
 	}
 
-	n = pwrite(fd, buf, HAMMER2_PBUFSIZE,
-		   volu_base + total_space - HAMMER2_PBUFSIZE);
-	if (n != HAMMER2_PBUFSIZE) {
-		perror("write (at-end-of-volume)");
-		exit(1);
-	}
-
 	/*
 	 * Make sure alloc_base won't cross the reserved area at the
 	 * beginning of each 1GB.
@@ -528,13 +492,32 @@ format_hammer2(int fd, hammer2_off_t total_space, hammer2_off_t free_space)
 	 */
 	for (tmp_base = boot_base; tmp_base < alloc_base;
 	     tmp_base += HAMMER2_PBUFSIZE) {
-		n = pwrite(fd, buf, HAMMER2_PBUFSIZE, tmp_base);
+		n = pwrite(vol->fd, buf, HAMMER2_PBUFSIZE, tmp_base);
 		if (n != HAMMER2_PBUFSIZE) {
 			perror("write (boot/aux)");
 			exit(1);
 		}
 	}
 
+	free(buf);
+	return(alloc_base);
+}
+
+static
+hammer2_off_t
+format_hammer2_inode(hammer2_volume_t *vol, hammer2_blockref_t *sroot_blockrefp,
+		     hammer2_off_t alloc_base)
+{
+	char *buf = malloc(HAMMER2_PBUFSIZE);
+	hammer2_inode_data_t *rawip;
+	hammer2_blockref_t sroot_blockref;
+	hammer2_blockref_t root_blockref[MAXLABELS];
+	uint64_t now;
+	size_t n;
+	int i;
+
+	bzero(&sroot_blockref, sizeof(sroot_blockref));
+	bzero(root_blockref, sizeof(root_blockref));
 	now = nowtime();
 	alloc_base &= ~HAMMER2_PBUFMASK64;
 	alloc_direct(&alloc_base, &sroot_blockref, HAMMER2_INODE_BYTES);
@@ -697,42 +680,118 @@ format_hammer2(int fd, hammer2_off_t total_space, hammer2_off_t free_space)
 	 */
 	assert((sroot_blockref.data_off & ~HAMMER2_PBUFMASK64) ==
 		((alloc_base - 1) & ~HAMMER2_PBUFMASK64));
-	n = pwrite(fd, buf, HAMMER2_PBUFSIZE,
+	n = pwrite(vol->fd, buf, HAMMER2_PBUFSIZE,
 		   sroot_blockref.data_off & ~HAMMER2_PBUFMASK64);
 	if (n != HAMMER2_PBUFSIZE) {
 		perror("write");
 		exit(1);
 	}
+	*sroot_blockrefp = sroot_blockref;
+
+	free(buf);
+	return(alloc_base);
+}
+
+/*
+ * Create the volume header, the super-root directory inode, and
+ * the writable snapshot subdirectory (named via the label) which
+ * is to be the initial mount point, or at least the first mount point.
+ * newfs_hammer2 doesn't format the freemap bitmaps for these.
+ *
+ * 0                      4MB
+ * [----reserved_area----][boot_area][aux_area]
+ * [[vol_hdr][freemap]...]                     [sroot][root][root]...
+ *     \                                        ^\     ^     ^
+ *      \--------------------------------------/  \---/-----/---...
+ *
+ * NOTE: The total size is 8MB-aligned to avoid edge cases.
+ */
+static
+void
+format_hammer2(hammer2_ondisk_t *fso, int index)
+{
+	char *buf = malloc(HAMMER2_PBUFSIZE);
+	hammer2_volume_t *vol = &fso->volumes[index];
+	hammer2_volume_data_t *voldata;
+	hammer2_blockset_t sroot_blockset;
+	hammer2_off_t boot_base = HAMMER2_ZONE_SEG;
+	hammer2_off_t aux_base = boot_base + BootAreaSize;
+	hammer2_off_t alloc_base;
+	size_t n;
+	int i;
+
+	/*
+	 * Make sure we can write to the last usable block.
+	 */
+	bzero(buf, HAMMER2_PBUFSIZE);
+	n = pwrite(vol->fd, buf, HAMMER2_PBUFSIZE,
+		   vol->size - HAMMER2_PBUFSIZE);
+	if (n != HAMMER2_PBUFSIZE) {
+		perror("write (at-end-of-volume)");
+		exit(1);
+	}
+
+	/*
+	 * Format misc area and sroot/root inodes for the root volume.
+	 */
+	bzero(&sroot_blockset, sizeof(sroot_blockset));
+	if (vol->id == HAMMER2_ROOT_VOLUME) {
+		alloc_base = format_hammer2_misc(vol, boot_base, aux_base);
+		alloc_base = format_hammer2_inode(vol,
+						  &sroot_blockset.blockref[0],
+						  alloc_base);
+	} else {
+		alloc_base = 0;
+		for (i = 0; i < HAMMER2_SET_COUNT; ++i)
+			sroot_blockset.blockref[i].type = HAMMER2_BREF_TYPE_INVALID;
+	}
 
 	/*
 	 * Format the volume header.
 	 *
-	 * The volume header points to sroot_blockref.  Also be absolutely
-	 * sure that allocator_beg is set.
+	 * The volume header points to sroot_blockset.  Also be absolutely
+	 * sure that allocator_beg is set for the root volume.
 	 */
 	assert(HAMMER2_VOLUME_BYTES <= HAMMER2_PBUFSIZE);
 	bzero(buf, HAMMER2_PBUFSIZE);
 	voldata = (void *)buf;
 
 	voldata->magic = HAMMER2_VOLUME_ID_HBO;
-	voldata->boot_beg = boot_base;
-	voldata->boot_end = boot_base + BootAreaSize;
-	voldata->aux_beg = aux_base;
-	voldata->aux_end = aux_base + AuxAreaSize;
-	voldata->volu_size = total_space;
+	if (vol->id == HAMMER2_ROOT_VOLUME) {
+		voldata->boot_beg = boot_base;
+		voldata->boot_end = boot_base + BootAreaSize;
+		voldata->aux_beg = aux_base;
+		voldata->aux_end = aux_base + AuxAreaSize;
+	}
+	voldata->volu_size = vol->size;
 	voldata->version = Hammer2Version;
 	voldata->flags = 0;
 
+	if (voldata->version >= HAMMER2_VOL_VERSION_MULTI_VOLUMES) {
+		voldata->volu_id = vol->id;
+		voldata->nvolumes = fso->nvolumes;
+		voldata->total_size = fso->total_size;
+		for (i = 0; i < HAMMER2_MAX_VOLUMES; ++i) {
+			if (i < fso->nvolumes)
+				voldata->volu_loff[i] = fso->volumes[i].offset;
+			else
+				voldata->volu_loff[i] = (hammer2_off_t)-1;
+		}
+	}
+
 	voldata->fsid = Hammer2_VolFSID;
 	voldata->fstype = Hammer2_FSType;
 
 	voldata->peer_type = DMSG_PEER_HAMMER2;	/* LNK_CONN identification */
 
-	voldata->allocator_size = free_space;
-	voldata->allocator_free = free_space;
-	voldata->allocator_beg = alloc_base;
+	assert(vol->id == HAMMER2_ROOT_VOLUME || alloc_base == 0);
+	voldata->allocator_size = fso->free_size;
+	if (vol->id == HAMMER2_ROOT_VOLUME) {
+		voldata->allocator_free = fso->free_size;
+		voldata->allocator_beg = alloc_base;
+	}
 
-	voldata->sroot_blockset.blockref[0] = sroot_blockref;
+	voldata->sroot_blockset = sroot_blockset;
 	voldata->mirror_tid = 16;	/* all blockref mirror TIDs set to 16 */
 	voldata->freemap_tid = 16;	/* all blockref mirror TIDs set to 16 */
 	voldata->icrc_sects[HAMMER2_VOL_ICRC_SECT1] =
@@ -755,15 +814,16 @@ format_hammer2(int fd, hammer2_off_t total_space, hammer2_off_t free_space)
 	 * Write the volume header and all alternates.
 	 */
 	for (i = 0; i < HAMMER2_NUM_VOLHDRS; ++i) {
-		if (i * HAMMER2_ZONE_BYTES64 >= total_space)
+		if (i * HAMMER2_ZONE_BYTES64 >= vol->size)
 			break;
-		n = pwrite(fd, buf, HAMMER2_PBUFSIZE,
-			   volu_base + i * HAMMER2_ZONE_BYTES64);
+		n = pwrite(vol->fd, buf, HAMMER2_PBUFSIZE,
+			   i * HAMMER2_ZONE_BYTES64);
 		if (n != HAMMER2_PBUFSIZE) {
 			perror("write");
 			exit(1);
 		}
 	}
+	fsync(vol->fd);
 
 	/*
 	 * Cleanup
diff --git a/sys/conf/files b/sys/conf/files
index 6cbeb09403..4d96eaa4e2 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -2031,6 +2031,7 @@ vfs/hammer2/hammer2_flush.c	optional hammer2
 vfs/hammer2/hammer2_msgops.c	optional hammer2
 vfs/hammer2/hammer2_freemap.c	optional hammer2
 vfs/hammer2/hammer2_strategy.c	optional hammer2
+vfs/hammer2/hammer2_ondisk.c	optional hammer2
 vfs/hammer2/xxhash/xxhash.c	optional hammer2
 vfs/hammer2/zlib/hammer2_zlib_adler32.c	optional hammer2
 vfs/hammer2/zlib/hammer2_zlib_inflate.c	optional hammer2
diff --git a/sys/vfs/hammer2/Makefile b/sys/vfs/hammer2/Makefile
index ab20061ff3..9c5abb19e3 100644
--- a/sys/vfs/hammer2/Makefile
+++ b/sys/vfs/hammer2/Makefile
@@ -15,7 +15,7 @@ KCFLAGS+= -DINVARIANTS
 #KCFLAGS+= -DZ_PREFIX -DXXH_NAMESPACE=h2_
 KMOD=	hammer2
 SRCS=	hammer2_vfsops.c hammer2_vnops.c hammer2_xops.c hammer2_inode.c
-SRCS+=	hammer2_strategy.c
+SRCS+=	hammer2_strategy.c hammer2_ondisk.c
 SRCS+=	hammer2_chain.c hammer2_flush.c hammer2_freemap.c hammer2_cluster.c
 SRCS+=	hammer2_ioctl.c hammer2_msgops.c hammer2_subr.c hammer2_bulkfree.c
 SRCS+=  hammer2_lz4.c hammer2_io.c hammer2_iocom.c hammer2_admin.c
diff --git a/sys/vfs/hammer2/hammer2.h b/sys/vfs/hammer2/hammer2.h
index 657c296579..1e6d0fbbb5 100644
--- a/sys/vfs/hammer2/hammer2.h
+++ b/sys/vfs/hammer2/hammer2.h
@@ -291,7 +291,9 @@ RB_HEAD(hammer2_io_tree, hammer2_io);
 struct hammer2_io {
 	RB_ENTRY(hammer2_io) rbnode;	/* indexed by device offset */
 	struct hammer2_dev *hmp;
+	struct vnode	*devvp;
 	struct buf	*bp;
+	off_t		dbase;		/* offset of devvp within volumes */
 	off_t		pbase;
 	uint64_t	refs;
 	int		psize;
@@ -1101,6 +1103,34 @@ typedef struct hammer2_xop_group hammer2_xop_group_t;
 #define HAMMER2_XOP_FSSYNC		0x00000010
 #define HAMMER2_XOP_IROOT		0x00000020
 
+/*
+ * Device vnode management structure
+ */
+struct hammer2_devvp {
+	TAILQ_ENTRY(hammer2_devvp) entry;
+	struct vnode	*devvp;		/* device vnode */
+	char		*path;		/* device vnode path */
+	int		open;		/* 1 if devvp open */
+};
+
+typedef struct hammer2_devvp hammer2_devvp_t;
+
+TAILQ_HEAD(hammer2_devvp_list, hammer2_devvp);
+
+typedef struct hammer2_devvp_list hammer2_devvp_list_t;
+
+/*
+ * Volume management structure
+ */
+struct hammer2_volume {
+	hammer2_devvp_t *dev;		/* device vnode management */
+	int		id;		/* volume id */
+	hammer2_off_t	offset;		/* offset within volumes */
+	hammer2_off_t	size;		/* volume size */
+};
+
+typedef struct hammer2_volume hammer2_volume_t;
+
 /*
  * Global (per partition) management structure, represents a hard block
  * device.  Typically referenced by hammer2_chain structures when applicable.
@@ -1113,7 +1143,7 @@ typedef struct hammer2_xop_group hammer2_xop_group_t;
  * the set of available clusters.
  */
 struct hammer2_dev {
-	struct vnode	*devvp;		/* device vnode */
+	struct vnode	*devvp;		/* device vnode for root volume */
 	int		ronly;		/* read-only mount */
 	int		mount_count;	/* number of actively mounted PFSs */
 	TAILQ_ENTRY(hammer2_dev) mntentry; /* hammer2_mntlist */
@@ -1138,11 +1168,16 @@ struct hammer2_dev {
 	int		volhdrno;	/* last volhdrno written */
 	uint32_t	hflags;		/* HMNT2 flags applicable to device */
 	hammer2_off_t	free_reserved;	/* nominal free reserved */
+	hammer2_off_t	total_size;	/* total size of volumes */
+	int		nvolumes;	/* total number of volumes */
 	hammer2_thread_t bfthr;		/* bulk-free thread */
 	char		devrepname[64];	/* for kprintf */
 	hammer2_ioc_bulkfree_t bflast;	/* stats for last bulkfree run */
 	hammer2_volume_data_t voldata;
 	hammer2_volume_data_t volsync;	/* synchronized voldata */
+
+	hammer2_devvp_list_t devvpl;	/* list of device vnodes including *devvp */
+	hammer2_volume_t volumes[HAMMER2_MAX_VOLUMES]; /* list of volumes */
 };
 
 typedef struct hammer2_dev hammer2_dev_t;
@@ -1945,6 +1980,20 @@ void hammer2_dedup_record(hammer2_chain_t *chain, hammer2_io_t *dio,
 				const char *data);
 void hammer2_dedup_clear(hammer2_dev_t *hmp);
 
+/*
+ * hammer2_ondisk.c
+ */
+int hammer2_open_devvp(const hammer2_devvp_list_t *devvpl, int ronly);
+int hammer2_close_devvp(const hammer2_devvp_list_t *devvpl, int ronly);
+int hammer2_init_devvp(const char *blkdevs, int rootmount,
+			hammer2_devvp_list_t *devvpl);
+void hammer2_cleanup_devvp(hammer2_devvp_list_t *devvpl);
+int hammer2_init_volumes(struct mount *mp, const hammer2_devvp_list_t *devvpl,
+			hammer2_volume_t *volumes,
+			hammer2_volume_data_t *rootvoldata,
+			struct vnode **rootvoldevvp);
+hammer2_volume_t *hammer2_get_volume(hammer2_dev_t *hmp, hammer2_off_t offset);
+
 /*
  * More complex inlines
  */
diff --git a/sys/vfs/hammer2/hammer2_bulkfree.c b/sys/vfs/hammer2/hammer2_bulkfree.c
index a8353461a1..c171083ef4 100644
--- a/sys/vfs/hammer2/hammer2_bulkfree.c
+++ b/sys/vfs/hammer2/hammer2_bulkfree.c
@@ -479,8 +479,8 @@ hammer2_bulkfree_pass(hammer2_dev_t *hmp, hammer2_chain_t *vchain,
 	 * Cap at the size needed to cover the whole volume to avoid
 	 * making an unnecessarily large allocation.
 	 */
-	if (size > hmp->voldata.volu_size / HAMMER2_FREEMAP_SIZEDIV) {
-		size = (hmp->voldata.volu_size + HAMMER2_FREEMAP_SIZEMASK) /
+	if (size > hmp->total_size / HAMMER2_FREEMAP_SIZEDIV) {
+		size = (hmp->total_size + HAMMER2_FREEMAP_SIZEMASK) /
 			HAMMER2_FREEMAP_SIZEDIV;
 	}
 
@@ -508,8 +508,8 @@ hammer2_bulkfree_pass(hammer2_dev_t *hmp, hammer2_chain_t *vchain,
 	 * 64KB leaf bitmap boundary which represents 2GB of storage.
 	 */
 	cbinfo.sbase = bfi->sbase;
-	if (cbinfo.sbase > hmp->voldata.volu_size)
-		cbinfo.sbase = hmp->voldata.volu_size;
+	if (cbinfo.sbase > hmp->total_size)
+		cbinfo.sbase = hmp->total_size;
 	cbinfo.sbase &= ~HAMMER2_FREEMAP_LEVEL1_MASK;
 	TAILQ_INIT(&cbinfo.list);
 
@@ -520,7 +520,7 @@ hammer2_bulkfree_pass(hammer2_dev_t *hmp, hammer2_chain_t *vchain,
 	 * get through all available storage.
 	 */
 	error = 0;
-	while (cbinfo.sbase < hmp->voldata.volu_size) {
+	while (cbinfo.sbase < hmp->total_size) {
 		/*
 		 * We have enough ram to represent (incr) bytes of storage.
 		 * Each 64KB of ram represents 2GB of storage.
@@ -545,8 +545,8 @@ hammer2_bulkfree_pass(hammer2_dev_t *hmp, hammer2_chain_t *vchain,
 
 		incr = size / HAMMER2_FREEMAP_LEVELN_PSIZE *
 		       HAMMER2_FREEMAP_LEVEL1_SIZE;
-		if (hmp->voldata.volu_size - cbinfo.sbase <= incr) {
-			cbinfo.sstop = hmp->voldata.volu_size;
+		if (hmp->total_size - cbinfo.sbase <= incr) {
+			cbinfo.sstop = hmp->total_size;
 			allmedia = 1;
 		} else {
 			cbinfo.sstop = cbinfo.sbase + incr;
@@ -650,7 +650,7 @@ hammer2_bulkfree_pass(hammer2_dev_t *hmp, hammer2_chain_t *vchain,
 
 	bfi->sstop = cbinfo.sbase;
 
-	incr = bfi->sstop / (hmp->voldata.volu_size / 10000);
+	incr = bfi->sstop / (hmp->total_size / 10000);
 	if (incr > 10000)
 		incr = 10000;
 
@@ -690,7 +690,7 @@ cbinfo_bmap_init(hammer2_bulkfree_info_t *cbinfo, size_t size)
 
 	lokey = (cbinfo->hmp->voldata.allocator_beg + HAMMER2_SEGMASK64) &
 		~HAMMER2_SEGMASK64;
-	hikey = cbinfo->hmp->voldata.volu_size & ~HAMMER2_SEGMASK64;
+	hikey = cbinfo->hmp->total_size & ~HAMMER2_SEGMASK64;
 
 	bzero(bmap, size);
 	while (size) {
@@ -759,7 +759,7 @@ h2_bulkfree_callback(hammer2_bulkfree_info_t *cbinfo, hammer2_blockref_t *bref)
 		return 0;
 	if (data_off < cbinfo->hmp->voldata.allocator_beg)
 		return 0;
-	if (data_off >= cbinfo->hmp->voldata.volu_size)
+	if (data_off >= cbinfo->hmp->total_size)
 		return 0;
 
 	/*
@@ -920,9 +920,9 @@ h2_bulkfree_sync(hammer2_bulkfree_info_t *cbinfo)
 		kprintf("%016jx-",
 			(intmax_t)cbinfo->sbase);
 
-	if (cbinfo->sstop > cbinfo->hmp->voldata.volu_size)
+	if (cbinfo->sstop > cbinfo->hmp->total_size)
 		kprintf("%016jx\n",
-			(intmax_t)cbinfo->hmp->voldata.volu_size);
+			(intmax_t)cbinfo->hmp->total_size);
 	else
 		kprintf("%016jx\n",
 			(intmax_t)cbinfo->sstop);
@@ -943,12 +943,12 @@ h2_bulkfree_sync(hammer2_bulkfree_info_t *cbinfo)
 	while (data_off < cbinfo->sstop) {
 		/*
 		 * The freemap is not used below allocator_beg or beyond
-		 * volu_size.
+		 * total_size.
 		 */
 
 		if (data_off < cbinfo->hmp->voldata.allocator_beg)
 			goto next;
-		if (data_off >= cbinfo->hmp->voldata.volu_size)
+		if (data_off >= cbinfo->hmp->total_size)
 			goto next;
 
 		/*
diff --git a/sys/vfs/hammer2/hammer2_disk.h b/sys/vfs/hammer2/hammer2_disk.h
index cbe30a615e..d2966fa9ff 100644
--- a/sys/vfs/hammer2/hammer2_disk.h
+++ b/sys/vfs/hammer2/hammer2_disk.h
@@ -713,6 +713,7 @@ typedef struct hammer2_blockref hammer2_blockref_t;
 #define HAMMER2_BREF_TYPE_DIRENT	4
 #define HAMMER2_BREF_TYPE_FREEMAP_NODE	5
 #define HAMMER2_BREF_TYPE_FREEMAP_LEAF	6
+#define HAMMER2_BREF_TYPE_INVALID	7
 #define HAMMER2_BREF_TYPE_FREEMAP	254	/* pseudo-type */
 #define HAMMER2_BREF_TYPE_VOLUME	255	/* pseudo-type */
 
@@ -1144,6 +1145,16 @@ typedef struct hammer2_inode_data hammer2_inode_data_t;
 #define HAMMER2_VOLUME_ID_HBO	0x48414d3205172011LLU
 #define HAMMER2_VOLUME_ID_ABO	0x11201705324d4148LLU
 
+/*
+ * If volume version is HAMMER2_VOL_VERSION_MULTI_VOLUMES or above, max
+ * HAMMER2_MAX_VOLUMES volumes are supported. There must be 1 (and only 1)
+ * volume with volume id HAMMER2_ROOT_VOLUME.
+ * Otherwise filesystem only supports 1 volume, and that volume must have
+ * volume id HAMMER2_ROOT_VOLUME(0) which was a reserved field then.
+ */
+#define HAMMER2_MAX_VOLUMES	64
+#define HAMMER2_ROOT_VOLUME	0
+
 struct hammer2_volume_data {
 	/*
 	 * sector #0 - 512 bytes
@@ -1160,8 +1171,10 @@ struct hammer2_volume_data {
 	uint8_t		copyid;			/* 0038 copyid of phys vol */
 	uint8_t		freemap_version;	/* 0039 freemap algorithm */
 	uint8_t		peer_type;		/* 003A HAMMER2_PEER_xxx */
-	uint8_t		reserved003B;		/* 003B */
-	uint32_t	reserved003C;		/* 003C */
+	uint8_t		volu_id;		/* 003B */
+	uint8_t		nvolumes;		/* 003C */
+	uint8_t		reserved003D;		/* 003D */
+	uint16_t	reserved003E;		/* 003E */
 
 	uuid_t		fsid;			/* 0040 */
 	uuid_t		fstype;			/* 0050 */
@@ -1192,7 +1205,9 @@ struct hammer2_volume_data {
 	hammer2_tid_t	reserved0088;		/* 0088 */
 	hammer2_tid_t	freemap_tid;		/* 0090 committed tid (fmap) */
 	hammer2_tid_t	bulkfree_tid;		/* 0098 bulkfree incremental */
-	hammer2_tid_t	reserved00A0[5];	/* 00A0-00C7 */
+	hammer2_tid_t	reserved00A0[4];	/* 00A0-00BF */
+
+	hammer2_off_t	total_size;		/* 00C0 Total volume size, bytes */
 
 	/*
 	 * Copyids are allocated dynamically from the copyexists bitmap.
@@ -1228,14 +1243,19 @@ struct hammer2_volume_data {
 	hammer2_blockset_t sroot_blockset;	/* 0200-03FF Superroot dir */
 
 	/*
-	 * sector #2-7
+	 * sector #2-6
 	 */
 	char	sector2[512];			/* 0400-05FF reserved */
 	char	sector3[512];			/* 0600-07FF reserved */
 	hammer2_blockset_t freemap_blockset;	/* 0800-09FF freemap  */
 	char	sector5[512];			/* 0A00-0BFF reserved */
 	char	sector6[512];			/* 0C00-0DFF reserved */
-	char	sector7[512];			/* 0E00-0FFF reserved */
+
+	/*
+	 * sector #7 - 512 bytes
+	 * Maximum 64 volume offsets within logical offset.
+	 */
+	hammer2_off_t volu_loff[HAMMER2_MAX_VOLUMES];
 
 	/*
 	 * sector #8-71	- 32768 bytes
@@ -1287,9 +1307,11 @@ typedef struct hammer2_volume_data hammer2_volume_data_t;
 #define HAMMER2_VOLUME_ICRC1_SIZE	(512)
 #define HAMMER2_VOLUME_ICRCVH_SIZE	(65536 - 4)
 
+#define HAMMER2_VOL_VERSION_MULTI_VOLUMES	2
+
 #define HAMMER2_VOL_VERSION_MIN		1
-#define HAMMER2_VOL_VERSION_DEFAULT	1
-#define HAMMER2_VOL_VERSION_WIP		2
+#define HAMMER2_VOL_VERSION_DEFAULT	HAMMER2_VOL_VERSION_MULTI_VOLUMES
+#define HAMMER2_VOL_VERSION_WIP		(HAMMER2_VOL_VERSION_MULTI_VOLUMES + 1)
 
 #define HAMMER2_NUM_VOLHDRS		4
 
diff --git a/sys/vfs/hammer2/hammer2_flush.c b/sys/vfs/hammer2/hammer2_flush.c
index 32506eb56d..534caa1172 100644
--- a/sys/vfs/hammer2/hammer2_flush.c
+++ b/sys/vfs/hammer2/hammer2_flush.c
@@ -1323,6 +1323,8 @@ hammer2_xop_inode_flush(hammer2_xop_t *arg, void *scratch __unused, int clindex)
 	hammer2_inode_t *ip;
 	hammer2_dev_t *hmp;
 	hammer2_pfs_t *pmp;
+	hammer2_devvp_t *e;
+	struct vnode *devvp;
 	int flush_error = 0;
 	int fsync_error = 0;
 	int total_error = 0;
@@ -1484,12 +1486,16 @@ hammer2_xop_inode_flush(hammer2_xop_t *arg, void *scratch __unused, int clindex)
 	 *
 	 * XXX this isn't being incremental
 	 */
-	vn_lock(hmp->devvp, LK_EXCLUSIVE | LK_RETRY);
-	fsync_error = VOP_FSYNC(hmp->devvp, MNT_WAIT, 0);
-	vn_unlock(hmp->devvp);
-	if (fsync_error || flush_error) {
-		kprintf("hammer2: sync error fsync=%d h2flush=0x%04x dev=%s\n",
-			fsync_error, flush_error, hmp->devrepname);
+	TAILQ_FOREACH(e, &hmp->devvpl, entry) {
+		devvp = e->devvp;
+		KKASSERT(devvp);
+		vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY);
+		fsync_error = VOP_FSYNC(devvp, MNT_WAIT, 0);
+		vn_unlock(devvp);
+		if (fsync_error || flush_error) {
+			kprintf("hammer2: sync error fsync=%d h2flush=0x%04x dev=%s\n",
+				fsync_error, flush_error, e->path);
+		}
 	}
 
 	/*
diff --git a/sys/vfs/hammer2/hammer2_freemap.c b/sys/vfs/hammer2/hammer2_freemap.c
index ecc1d11fcb..97e2c0483d 100644
--- a/sys/vfs/hammer2/hammer2_freemap.c
+++ b/sys/vfs/hammer2/hammer2_freemap.c
@@ -272,8 +272,8 @@ hammer2_freemap_alloc(hammer2_chain_t *chain, size_t bytes)
 	 * Make sure bpref is in-bounds.  It's ok if bpref covers a zone's
 	 * reserved area, the try code will iterate past it.
 	 */
-	if (iter.bpref > hmp->voldata.volu_size)
-		iter.bpref = hmp->voldata.volu_size - 1;
+	if (iter.bpref > hmp->total_size)
+		iter.bpref = hmp->total_size - 1;
 
 	/*
 	 * Iterate the freemap looking for free space before and after.
@@ -515,7 +515,7 @@ hammer2_freemap_try_alloc(hammer2_chain_t **parentp,
 		 * reserved segment area for a zone.
 		 */
 		KKASSERT(key >= hmp->voldata.allocator_beg &&
-			 key + bytes <= hmp->voldata.volu_size);
+			 key + bytes <= hmp->total_size);
 		KKASSERT((key & HAMMER2_ZONE_MASK64) >= HAMMER2_ZONE_SEG);
 		bref->data_off = key | radix;
 
@@ -878,8 +878,8 @@ hammer2_freemap_init(hammer2_dev_t *hmp, hammer2_key_t key,
 	 *     allocated.
 	 */
 	hikey = key + HAMMER2_FREEMAP_LEVEL1_SIZE;
-	if (hikey > hmp->voldata.volu_size) {
-		hikey = hmp->voldata.volu_size & ~HAMMER2_SEGMASK64;
+	if (hikey > hmp->total_size) {
+		hikey = hmp->total_size & ~HAMMER2_SEGMASK64;
 	}
 
 	/*
@@ -927,7 +927,7 @@ hammer2_freemap_iterate(hammer2_chain_t **parentp, hammer2_chain_t **chainp,
 
 	iter->bnext &= ~HAMMER2_FREEMAP_LEVEL1_MASK;
 	iter->bnext += HAMMER2_FREEMAP_LEVEL1_SIZE;
-	if (iter->bnext >= hmp->voldata.volu_size) {
+	if (iter->bnext >= hmp->total_size) {
 		iter->bnext = 0;
 		if (++iter->loops >= 2) {
 			if (iter->relaxed == 0)
